//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ninZaQuickDrawing[] cacheninZaQuickDrawing = null;

        private static ninZaQuickDrawing checkninZaQuickDrawing = new ninZaQuickDrawing();

        /// <summary>
        /// Quick Drawing by ninZa.co
        /// </summary>
        /// <returns></returns>
        public ninZaQuickDrawing ninZaQuickDrawing(Color toolStripColor, System.Windows.Forms.DockStyle toolStripDockStyle, string update, bool visibleChannels, bool visibleControls, bool visibleFibs, bool visibleLines, bool visibleMarkers, bool visibleShapes, string website)
        {
            return ninZaQuickDrawing(Input, toolStripColor, toolStripDockStyle, update, visibleChannels, visibleControls, visibleFibs, visibleLines, visibleMarkers, visibleShapes, website);
        }

        /// <summary>
        /// Quick Drawing by ninZa.co
        /// </summary>
        /// <returns></returns>
        public ninZaQuickDrawing ninZaQuickDrawing(Data.IDataSeries input, Color toolStripColor, System.Windows.Forms.DockStyle toolStripDockStyle, string update, bool visibleChannels, bool visibleControls, bool visibleFibs, bool visibleLines, bool visibleMarkers, bool visibleShapes, string website)
        {
            if (cacheninZaQuickDrawing != null)
                for (int idx = 0; idx < cacheninZaQuickDrawing.Length; idx++)
                    if (cacheninZaQuickDrawing[idx].ToolStripColor == toolStripColor && cacheninZaQuickDrawing[idx].ToolStripDockStyle == toolStripDockStyle && cacheninZaQuickDrawing[idx].Update == update && cacheninZaQuickDrawing[idx].VisibleChannels == visibleChannels && cacheninZaQuickDrawing[idx].VisibleControls == visibleControls && cacheninZaQuickDrawing[idx].VisibleFibs == visibleFibs && cacheninZaQuickDrawing[idx].VisibleLines == visibleLines && cacheninZaQuickDrawing[idx].VisibleMarkers == visibleMarkers && cacheninZaQuickDrawing[idx].VisibleShapes == visibleShapes && cacheninZaQuickDrawing[idx].Website == website && cacheninZaQuickDrawing[idx].EqualsInput(input))
                        return cacheninZaQuickDrawing[idx];

            lock (checkninZaQuickDrawing)
            {
                checkninZaQuickDrawing.ToolStripColor = toolStripColor;
                toolStripColor = checkninZaQuickDrawing.ToolStripColor;
                checkninZaQuickDrawing.ToolStripDockStyle = toolStripDockStyle;
                toolStripDockStyle = checkninZaQuickDrawing.ToolStripDockStyle;
                checkninZaQuickDrawing.Update = update;
                update = checkninZaQuickDrawing.Update;
                checkninZaQuickDrawing.VisibleChannels = visibleChannels;
                visibleChannels = checkninZaQuickDrawing.VisibleChannels;
                checkninZaQuickDrawing.VisibleControls = visibleControls;
                visibleControls = checkninZaQuickDrawing.VisibleControls;
                checkninZaQuickDrawing.VisibleFibs = visibleFibs;
                visibleFibs = checkninZaQuickDrawing.VisibleFibs;
                checkninZaQuickDrawing.VisibleLines = visibleLines;
                visibleLines = checkninZaQuickDrawing.VisibleLines;
                checkninZaQuickDrawing.VisibleMarkers = visibleMarkers;
                visibleMarkers = checkninZaQuickDrawing.VisibleMarkers;
                checkninZaQuickDrawing.VisibleShapes = visibleShapes;
                visibleShapes = checkninZaQuickDrawing.VisibleShapes;
                checkninZaQuickDrawing.Website = website;
                website = checkninZaQuickDrawing.Website;

                if (cacheninZaQuickDrawing != null)
                    for (int idx = 0; idx < cacheninZaQuickDrawing.Length; idx++)
                        if (cacheninZaQuickDrawing[idx].ToolStripColor == toolStripColor && cacheninZaQuickDrawing[idx].ToolStripDockStyle == toolStripDockStyle && cacheninZaQuickDrawing[idx].Update == update && cacheninZaQuickDrawing[idx].VisibleChannels == visibleChannels && cacheninZaQuickDrawing[idx].VisibleControls == visibleControls && cacheninZaQuickDrawing[idx].VisibleFibs == visibleFibs && cacheninZaQuickDrawing[idx].VisibleLines == visibleLines && cacheninZaQuickDrawing[idx].VisibleMarkers == visibleMarkers && cacheninZaQuickDrawing[idx].VisibleShapes == visibleShapes && cacheninZaQuickDrawing[idx].Website == website && cacheninZaQuickDrawing[idx].EqualsInput(input))
                            return cacheninZaQuickDrawing[idx];

                ninZaQuickDrawing indicator = new ninZaQuickDrawing();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.ToolStripColor = toolStripColor;
                indicator.ToolStripDockStyle = toolStripDockStyle;
                indicator.Update = update;
                indicator.VisibleChannels = visibleChannels;
                indicator.VisibleControls = visibleControls;
                indicator.VisibleFibs = visibleFibs;
                indicator.VisibleLines = visibleLines;
                indicator.VisibleMarkers = visibleMarkers;
                indicator.VisibleShapes = visibleShapes;
                indicator.Website = website;
                Indicators.Add(indicator);
                indicator.SetUp();

                ninZaQuickDrawing[] tmp = new ninZaQuickDrawing[cacheninZaQuickDrawing == null ? 1 : cacheninZaQuickDrawing.Length + 1];
                if (cacheninZaQuickDrawing != null)
                    cacheninZaQuickDrawing.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheninZaQuickDrawing = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Quick Drawing by ninZa.co
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ninZaQuickDrawing ninZaQuickDrawing(Color toolStripColor, System.Windows.Forms.DockStyle toolStripDockStyle, string update, bool visibleChannels, bool visibleControls, bool visibleFibs, bool visibleLines, bool visibleMarkers, bool visibleShapes, string website)
        {
            return _indicator.ninZaQuickDrawing(Input, toolStripColor, toolStripDockStyle, update, visibleChannels, visibleControls, visibleFibs, visibleLines, visibleMarkers, visibleShapes, website);
        }

        /// <summary>
        /// Quick Drawing by ninZa.co
        /// </summary>
        /// <returns></returns>
        public Indicator.ninZaQuickDrawing ninZaQuickDrawing(Data.IDataSeries input, Color toolStripColor, System.Windows.Forms.DockStyle toolStripDockStyle, string update, bool visibleChannels, bool visibleControls, bool visibleFibs, bool visibleLines, bool visibleMarkers, bool visibleShapes, string website)
        {
            return _indicator.ninZaQuickDrawing(input, toolStripColor, toolStripDockStyle, update, visibleChannels, visibleControls, visibleFibs, visibleLines, visibleMarkers, visibleShapes, website);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Quick Drawing by ninZa.co
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ninZaQuickDrawing ninZaQuickDrawing(Color toolStripColor, System.Windows.Forms.DockStyle toolStripDockStyle, string update, bool visibleChannels, bool visibleControls, bool visibleFibs, bool visibleLines, bool visibleMarkers, bool visibleShapes, string website)
        {
            return _indicator.ninZaQuickDrawing(Input, toolStripColor, toolStripDockStyle, update, visibleChannels, visibleControls, visibleFibs, visibleLines, visibleMarkers, visibleShapes, website);
        }

        /// <summary>
        /// Quick Drawing by ninZa.co
        /// </summary>
        /// <returns></returns>
        public Indicator.ninZaQuickDrawing ninZaQuickDrawing(Data.IDataSeries input, Color toolStripColor, System.Windows.Forms.DockStyle toolStripDockStyle, string update, bool visibleChannels, bool visibleControls, bool visibleFibs, bool visibleLines, bool visibleMarkers, bool visibleShapes, string website)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ninZaQuickDrawing(input, toolStripColor, toolStripDockStyle, update, visibleChannels, visibleControls, visibleFibs, visibleLines, visibleMarkers, visibleShapes, website);
        }
    }
}
#endregion
